## pushpin 1.41.0

=== Makefile ===
# controlled leading whitespace, per the GNU make manual
nullstring :=
space := $(nullstring) # end of the line

ifdef RELEASE
cargo_flags = $(space)--offline --locked --release
endif

ifdef TOOLCHAIN
cargo_toolchain = $(space)+$(TOOLCHAIN)
endif

all: postbuild

build: FORCE
	cargo$(cargo_toolchain) build$(cargo_flags)

cargo-test: FORCE
	cargo$(cargo_toolchain) test$(cargo_flags) --all-features

cargo-clean: FORCE
	cargo clean

postbuild: build FORCE
	cd postbuild && $(MAKE) -f Makefile

postbuild-install: FORCE
	cd postbuild && $(MAKE) -f Makefile install

postbuild-clean: FORCE
	cd postbuild && $(MAKE) -f Makefile clean

postbuild-distclean: FORCE
	cd postbuild && $(MAKE) -f Makefile distclean

check: cargo-test

install: postbuild-install

clean: cargo-clean postbuild-clean

distclean: cargo-clean postbuild-distclean

FORCE:

=== debian/changelog ===
pushpin (1.41.0-3) unstable; urgency=medium

  * Build using dh-cargo. (Closes: #1047541)

 -- Jan Niehusmann <jan@debian.org>  Tue, 18 Nov 2025 21:10:54 +0100

pushpin (1.41.0-2) unstable; urgency=medium

  * Pushpin no longer needs zurl - don't depend on it.
  * Replace dependency on pkg-config by pkgconf.
  * Remove dependency on lsb-base.
  * Fixed several lintian warnings.

 -- Jan Niehusmann <jan@debian.org>  Sat, 15 Nov 2025 22:33:21 +0100

pushpin (1.41.0-1) unstable; urgency=medium

  * New upstream version
  * Adjusted several dependencies to versions available in rust.
  * Thanks to Peter Green for providing a patch covering most of the
    required changes.
  * Closes: #1098294

 -- Jan Niehusmann <jan@debian.org>  Fri, 14 Nov 2025 23:33:39 +0100

=== debian/control ===
Source: pushpin
Section: net
Priority: optional
Maintainer: Jan Niehusmann <jan@debian.org>
Build-Depends: debhelper (>= 11), qtbase5-dev, qt5-qmake, qtchooser, libzmq3-dev (>= 2.0), pkgconf, qconf, cargo (>= 0.43), librust-clap-dev, librust-log-dev, librust-serde-dev, librust-serde-json-dev, librust-zmq-dev (>= 0.9.2-3), librust-serde-derive-dev, librust-base64-dev, librust-slab-dev, librust-jsonwebtoken-dev, librust-config-dev, librust-httparse-dev, librust-ipnet-dev, librust-miniz-oxide-dev, librust-mio-dev, librust-openssl-dev, librust-paste-dev, librust-rustls-dev, librust-rustls-native-certs-dev, librust-sha1-dev, librust-signal-hook-dev, librust-socket2-dev, librust-criterion-dev, libboost-dev, librust-url-dev, help2man, librust-cbindgen-dev, librust-test-log-dev, librust-notify-dev, debhelper-compat (= 11), dh-cargo
Standards-Version: 4.7.2
Homepage: https://github.com/fanout/pushpin
Vcs-Git: https://salsa.debian.org/jan/pushpin.git
Vcs-Browser: https://salsa.debian.org/jan/pushpin

Package: pushpin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, ucf
Description: HTTP reverse proxy server for streaming and long-polling services
 Pushpin is a reverse proxy server that makes it easy to implement
 WebSocket, HTTP streaming, and HTTP long-polling services. It communicates
 with backend web applications using regular, short-lived HTTP requests
 (GRIP protocol). This allows backend applications to be written in any
 language and use any webserver.
 .
 Additionally, Pushpin does all of this without exposing a proprietary
 protocol to clients. The HTTP/WebSocket content between the client
 and your server is whatever you want it to be. This makes it ideal for
 implementing APIs.
 .
 Pushpin is written in C++. The name means to "pin" (hold) connections
 open for "pushing".

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export CARGO_HOME=$(CURDIR)/debian/cargo_home

ALLOW_MULTIPLE=-Wl,--allow-multiple-definition

define QMAKE_BUILDFLAGS
QMAKE_CPPFLAGS *= $(shell dpkg-buildflags --get CPPFLAGS)
QMAKE_CFLAGS   *= $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
QMAKE_CXXFLAGS *= $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
QMAKE_LFLAGS   *= $(shell dpkg-buildflags --get LDFLAGS) $(if $(findstring arm,$(shell uname -m)),$(ALLOW_MULTIPLE))
endef
export QMAKE_BUILDFLAGS

# for cargo
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
export PREFIX=/usr
export CONFIGDIR=/etc
export PATH := /usr/share/cargo/bin:$(PATH)
export CARGO=/usr/share/cargo/bin/cargo
export CARGO_HOME=$(CURDIR)/debian/cargo_home
export DEB_CARGO_CRATE=$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM)

%:
	dh $@

execute_before_dh_auto_configure:
	/usr/share/cargo/bin/cargo prepare-debian debian/cargo_registry --link-from-system

execute_after_dh_auto_install:
	/usr/share/cargo/bin/dh-cargo-built-using pushpin

override_dh_auto_configure:
	# Upstream Cargo.lock contains versions not valid for debian
	-rm Cargo.lock
	cargo update

override_dh_auto_install:
	dh_auto_install -- INSTALL_ROOT="$(CURDIR)/debian/pushpin"
	mkdir -p debian/pushpin/var/log/pushpin
	mkdir -p debian/pushpin/usr/share/pushpin
	mv debian/pushpin/etc/pushpin/pushpin.conf debian/pushpin/usr/share/pushpin/pushpin.conf

override_dh_installexamples:
	dh_installexamples -X.o -XMakefile

override_dh_installman:
	help2man \
		--name "HTTP/WebSocket connection manager" \
		--no-info \
		debian/pushpin/usr/bin/pushpin-connmgr > debian/pushpin-connmgr.1
	ln -s pushpin-connmgr.1 debian/pushpin-condure.1
	dh_installman -O--buildsystem=cargo
